/*******************************************************************************
 * Copyright (c) 2012 Simon Urli.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the GNU Public License v3.0
 * which accompanies this distribution, and is available at
 * http://www.gnu.org/licenses/gpl.html
 * 
 * Contributors:
 *     Simon Urli - initial API and implementation
 ******************************************************************************/
package fr.unice.i3s.modalis.yourcast.featureModel;

/**
 * A very simple representation of a feature model with a name and a set of features represented as a string.
 *
 * @author urli
 *
 */
public class FeatureModel {

	private String name;
	private String features;
	
	public FeatureModel(String name) {
		this.name = name;
	}
	
	public FeatureModel(String name, String features) {
		this.name = name;
		this.features = features;
	}
	
	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getFeatures() {
		return features;
	}

	public void setFeatures(String features) {
		this.features = features;
	}
	
	public FeatureModel clone() {
		return new FeatureModel(this.name, this.features);
	}
	
	public String toString() {
		return this.name+": ["+this.features+"]";
	}
	
	public boolean equals(Object o) {
		if (o instanceof FeatureModel) {
			FeatureModel fm = (FeatureModel)o;
			return (this.name.equals(fm.name) && this.features.equals(fm.features));
		}
		return false;
	}
	
	public static void intersectFM(FeatureModel fm1, FeatureModel fm2) {
		String[] fm1Split = fm1.getFeatures().split(",");
		String[] fm2Split = fm2.getFeatures().split(",");
		String features = "";
		
		for (String f1 : fm1Split) {
			for (String f2 : fm2Split) {
				if (f1.equals(f2))
					features += f1+",";
			}
		}
		if (features.length() > 0)
			features = features.substring(0, features.length()-1);
		fm1.setFeatures(features);
	}
}
