/*******************************************************************************
 * Copyright (c) 2012 Simon Urli.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the GNU Public License v3.0
 * which accompanies this distribution, and is available at
 * http://www.gnu.org/licenses/gpl.html
 * 
 * Contributors:
 *     Simon Urli - initial API and implementation
 ******************************************************************************/

package fr.unice.i3s.modalis.yourcast.multipleSPL;

import fr.unice.i3s.modalis.yourcast.featureModel.FeatureModel;

/**
 * One implementation of a restriction function where the intersection between features is used.
 * @author urli
 *
 */
public class IntersectionRestrictionFunction implements RestrictionFunction {

	public static IntersectionRestrictionFunction instance = new IntersectionRestrictionFunction();
	
	private IntersectionRestrictionFunction() {}
	
	public void restrictFeatureModel(FeatureModel target, FeatureModel source) {
		String[] fmSplit = target.getFeatures().split(",");
		String[] cSplit = source.getFeatures().split(",");
		String features = "";
		
		
		for (String f : fmSplit) {
			String[] fSplitW = f.split("-");
			for (String fw : fSplitW) {
				for (String fc : cSplit) {
					if ((fc.contains(fw) || fw.contains(fc)) && !features.contains(f))
						features += f+",";
				}	
			}
		}
		if (features.length() > 0)
			features = features.substring(0, features.length()-1);
		target.setFeatures(features);
	}

}
